meta:
  id: ss_f1_sochipro_bin
  file-extension: bin
  endian: le
  license: WTFPL
doc-ref: |
  * update url
  http://www.silverstonef1.ru/obnovleniya/
  * direct firmware download links guide
  https://rd-forum.ru/threads/silverstone-f1-sochi-pro.8480/page-70#post-526913

instances:
  header:
    pos: 0x0  # absolute
    type: header
  fw:
    pos: 0x10 # absolute
    type: fw
  voice:
    pos: 0x05d010 # POSSIBLY ABSOLUTE offset in file
    type: sound_index
  db:
    pos: 0x43d010 # POSSIBLY ABSOLUTE offset in file
    type: db

types:
  header:
    seq:
      - id: byte_unknown
        size: 1
      - id: size_fw
        type: u4le
      - id: size_voice
        type: u4le
      - id: size_db
        type: u4le
      - id: bytes_align
        size: 3

  fw:
    instances:
      version:
        io: _root._io
        pos: (0x10 + _root.header.size_fw - 4)
        size: 4
      raw_data:
        io: _root._io
        pos: (0x10)
        size: _root.header.size_fw

  sound_index:
    seq:
      - id: version
        size: 4 
      - id: item
        type: sound_item
        # variant A : constant value, always works, BUT needs manual set
        #repeat: expr
        #repeat-expr: 128
        # variant B : auto-mode, but has some notes: last element in array has invalid content
        # doc-ref : https://doc.kaitai.io/user_guide.html#_repetitions
        repeat: until
        repeat-until: _.size_a == 0xffffffff
    instances:
      raw_data:
        io: _root._io
        pos: (0x05d010)
        size: _root.header.size_voice

  sound_item:
    seq:
      - id: size_a
        type: u4
      - id: offset
        type: u4
    instances:
      raw_data:
        io: _root._io
        pos: (0x05d010 + 0x04 + offset)
        size: size_a

  db:
    seq:
      - id: unknown_bytes
        size: 4
      - id: counter_poi_x
        type: u4
      - id: counter_poi_y
        type: u4
      - id: version
        type: str
        size: 11
        encoding: ASCII
      - id: poi_a
        type: poi_a
        repeat: expr
        repeat-expr: counter_poi_x + 1
      - id: poi_b
        type: poi_b
        repeat: expr
        repeat-expr: counter_poi_y
    instances:
      raw_data:
        io: _root._io
        pos: (0x43d010)
        size: _root.header.size_db
  
  poi_a:
    seq:
      - id: poi_ref
        size: 4
      - id: unk_dd
        size: 2
      - id: unk_int
        type: u4le
  
  poi_b:
    seq:
      - id: poi_ref
        size: 4
      - id: coord_dolg
        type: s4le
        doc: |
          to get ',' - devide by 10000
      - id: coord_shir
        type: s4le
        doc: |
          to get ',' - devide by 10000
      - id: type_unknown_1
        size: 3
      - id: type_unknown_2
        size: 1
      - id: type_unknown_3
        size: 1
      - id: speed_limit
        size: 1
      - id: type_unknown_4
        size: 2
      - id: angle
        type: u2le
      - id: type_unknown_5
        size: 6
